
; RAM
.definelabel BackupOf4000000,0x3000088
.definelabel CurrSpriteData,0x3000738
.definelabel SamusData,0x30013D4

; functions
.definelabel CheckEndOfSpriteAnim,0x800FC00
.definelabel CheckSamusNearSprite,0x800FDE0
; 2E-32 = 2C-30
.definelabel SpriteMovement,0x8010944

; ROM
.definelabel HoverMovementTable,0x82CD604


Pose0_Init:
    push    r4,r5,r14
    ldr     r2,=CurrSpriteData
    mov     r0,r2
    add     r0,32h         ; sprite collision properties
    ldrb    r1,[r0]
    mov     r0,2h
    and     r0,r1
    cmp     r0,0h
    beq     @@Spawn        ; if collision has 2
    ldrh    r1,[r2]          ; sprite status
    mov     r0,80h
    lsl     r0,r0,6h
    and     r0,r1
    lsl     r0,r0,10h
    lsr     r0,r0,10h
    cmp     r0,0h
    bne     @@Spawn          ; if status has 2000
    strh    r0,[r2]            ; removes sprite
    b       @@Return
    .pool
@@Spawn:
    ldr     r0,=CurrSpriteData
    mov     r12,r0
    add     r0,27h
    mov     r4,0h          ; r4 = 0
    mov     r2,10h
    strb    r2,[r0]        ; sprite[27] = 10
    mov     r1,r12
    add     r1,28h
    mov     r3,8h          ; r3 = 8
    mov     r0,8h
    strb    r0,[r1]        ; sprite[28] = 8
    mov     r0,r12
    add     r0,29h
    strb    r2,[r0]        ; sprite[29] = 10
    mov     r5,0h          ; r5 = 0
    ldr     r0,=0FFC0h
    mov     r1,r12
    strh    r0,[r1,0Ah]    ; top
    strh    r4,[r1,0Ch]    ; bottom
    add     r0,20h
    strh    r0,[r1,0Eh]    ; left
    mov     r0,20h
    strh    r0,[r1,10h]    ; right
    strb    r5,[r1,1Ch]    ; AnimCounter = 0
    strh    r4,[r1,16h]    ; Animation = 0
    ldr     r2,=PrimarySpriteStats
    ldrb    r1,[r1,1Dh]    ; r1 = SpriteID
    lsl     r0,r1,4h
    add     r0,r0,r1
    add     r0,r0,r1
    add     r0,r0,r2
    ldrh    r0,[r0]
    mov     r1,r12
    strh    r0,[r1,14h]    ; store health
    add     r1,32h         ; sprite collision properties
    ldrb    r0,[r1]
    orr     r3,r0
    strb    r3,[r1]        ; Collision |= 8
    mov     r0,r12
    add     r0,25h
    strb    r5,[r0]        ; sprite[25] = 0
    sub     r1,0Eh         ; SpritePose
    mov     r0,1h
    strb    r0,[r1]        ; SpritePose = 1
@@Return:
    pop     r4,r5
    pop     r0
    bx      r0
    .pool


Pose1_StartWaiting:
    ldr     r1,=CurrSpriteData
    mov     r3,r1
    add     r3,24h
    mov     r2,0h
    mov     r0,2h
    strb    r0,[r3]        ; SpritePose = 2
    strb    r2,[r1,1Ch]    ; AnimCounter = 0
    strh    r2,[r1,16h]    ; Animation = 0
    bx      r14
    .pool


Pose2_Waiting:
    push    r4,r14
    ldr     r4,=CurrSpriteData
    ldrh    r1,[r4]
    mov     r0,80h
    lsl     r0,r0,6h
    and     r0,r1
    cmp     r0,0h
    bne     @@Return       ; if status doesn't have 2000
    mov     r0,0C0h
    mov     r1,0C0h
    bl      CheckSamusNearSprite
    lsl     r0,r0,18h
    cmp     r0,0h
    beq     @@Return
    mov     r1,r4            ; if samus near sprite
    add     r1,24h
    mov     r0,17h
    strb    r0,[r1]            ; SpritePose = 17
@@Return:
    pop     r4
    pop     r0
    bx      r0
    .pool


Pose17_StartWaking:
    ldr     r3,=CurrSpriteData
    mov     r2,r3
    add     r2,24h
    mov     r1,0h
    mov     r0,18h
    strb    r0,[r2]        ; SpritePose = 18
    strb    r1,[r3,1Ch]    ; AnimCounter = 0
    strh    r1,[r3,16h]    ; Animation = 0
    mov     r1,r3
    add     r1,25h
    mov     r0,4h
    strb    r0,[r1]        ; sprite[25] = 4
    add     r2,0Eh
    ldrb    r1,[r2]
    mov     r0,0F7h
    and     r0,r1
    strb    r0,[r2]        ; Collision &= F7
    ldr     r0,=BackupOf4000000
    ldrb    r1,[r0,0Ah]    ; r1 = BG1CNT
    mov     r0,3h
    and     r0,r1
    mov     r1,r3
    add     r1,21h
    strb    r0,[r1]        ; BgPriority = BG1CNT & 3
    bx      r14
    .pool


Pose18_Waking:
    push    r14
    bl      CheckEndOfSpriteAnim
    cmp     r0,0h
    beq     @@Return
    ldr     r0,=CurrSpriteData
    add     r0,24h
    mov     r1,19h
    strb    r1,[r0]        ; SpritePose = 19
@@Return:
    pop     r0
    bx      r0
    .pool


Pose19_StartRising:
    ldr     r3,=CurrSpriteData
    mov     r2,r3
    add     r2,24h
    mov     r1,0h
    mov     r0,1Ah
    strb    r0,[r2]        ; SpritePose = 1A
    mov     r0,r3
    add     r0,2Fh
    strb    r1,[r0]        ; sprite[2F] = 0
    add     r2,8h
    mov     r0,3Ch
    strb    r0,[r2]        ; sprite[2C] = 3C
    add     r2,1h
    strb    r0,[r2]        ; sprite[2D] = 3C
    strb    r1,[r3,1Ch]    ; AnimCounter = 0
    strh    r1,[r3,16h]    ; Animation = 0
    bx      r14
    .pool


Pose1A_Rising:
    push    r4-r6,r14
    ldr     r2,=CurrSpriteData
    mov     r1,r2
    add     r1,2Ch
    ldrb    r0,[r1]
    cmp     r0,0h
    beq     @@Risen1
    sub     r0,1h          ; if sprite[2C] > 0
    strb    r0,[r1]          ; sprite[2C]--
    ldrh    r0,[r2,2h]
    sub     r0,4h
    strh    r0,[r2,2h]       ; SpriteY -= 4
    b       @@Return         ; return
    .pool
@@Risen1:
    mov     r0,2Fh
    add     r0,r0,r2
    mov     r12,r0         ; r12 = sprite2F
    ldrb    r3,[r0]        ; r3 = sprite[2F]
    ldr     r5,=HoverMovementTable
    lsl     r0,r3,1h
    add     r0,r0,r5
    ldrh    r4,[r0]        ; r4 = [837CEEC + sprite[2F] * 2]
    mov     r6,0h
    ldsh    r1,[r0,r6]
    ldr     r0,=7FFFh
    cmp     r1,r0
    bne     @@Risen2       ; if r4 == 7FFF
    ldrh    r4,[r5]          ; r4 = [837CEEC] (0)
    mov     r3,0h            ; r3 = 0
@@Risen2:
    add     r0,r3,1        ; r0 = r3 + 1
    mov     r1,r12
    strb    r0,[r1]        ; sprite[2F] = r3 + 1
    ldrh    r0,[r2,2h]
    add     r0,r0,r4
    strh    r0,[r2,2h]     ; SpriteY += r4
    mov     r1,r2
    add     r1,2Dh
    ldrb    r0,[r1]
    sub     r0,1h
    strb    r0,[r1]        ; sprite[2D]--
    lsl     r0,r0,18h
    cmp     r0,0h
    bne     @@Return       ; if sprite[2D] == 0
    sub     r1,9h
    mov     r0,1Bh
    strb    r0,[r1]          ; SpritePose = 1B
@@Return:
    pop     r4-r6
    pop     r0
    bx      r0
    .pool


Pose1B_StartFlying:
    ldr     r0,=CurrSpriteData
    mov     r12,r0
    mov     r1,r12
    add     r1,24h
    mov     r2,0h
    mov     r0,1Ch
    strb    r0,[r1]        ; SpritePose = 1C
    mov     r3,0h
    mov     r0,96h
    lsl     r0,r0,1h
    mov     r1,r12
    strh    r0,[r1,6h]     ; sprite[06] = 12C (leave timer)
    strh    r2,[r1,8h]     ; sprite[08] = 0
    mov     r0,r12
    add     r0,2Dh
    strb    r3,[r0]        ; sprite[2D] = 0
    add     r0,1h
    mov     r1,1h
    strb    r1,[r0]        ; sprite[2E] = 1
    sub     r0,2h
    strb    r3,[r0]        ; sprite[2C] = 0
    add     r0,3h
    strb    r1,[r0]        ; sprite[2F] = 1
    bx      r14
    .pool


Pose1C_Flying:
    push    r14
    add     sp,-4h
    ldr     r0,=SamusData
    ldrh    r3,[r0,14h]    ; r3 = SamusY
    ldrh    r2,[r0,12h]    ; r2 = SamusX
    ldr     r1,=CurrSpriteData
    ldrh    r0,[r1,8h]     ; r0 = sprite[08]
    cmp     r0,1h
    beq     @@Branch1
    cmp     r0,3h
    beq     @@Branch2
    b       @@Branch5
    .pool
@@Branch1:
    mov     r0,r3          ; if sprite[08] == 1
    sub     r0,48h
    lsl     r0,r0,10h
    lsr     r3,r0,10h        ; r3 = TargetY - 48
    ldrh    r1,[r1]
    mov     r0,80h
    lsl     r0,r0,2h
    and     r0,r1
    cmp     r0,0h
    bne     @@Branch3        ; if status doesn't have 200
    mov     r0,r2
    sub     r0,48h             ; r0 = TargetX - 48
    b       @@Branch4
@@Branch2:
    mov     r0,r3          ; else if sprite[08] == 3
    add     r0,48h
    lsl     r0,r0,10h
    lsr     r3,r0,10h        ; r3 = TargetY + 48
    ldrh    r1,[r1]
    mov     r0,80h
    lsl     r0,r0,2h
    and     r0,r1
    cmp     r0,0h
    beq     @@Branch3        ; if status has 100
    mov     r0,r2
    sub     r0,48h             ; r0 = TargetX - 48
    b       @@Branch4
@@Branch3:
    mov     r0,r2          ; else
    add     r0,48h           ; r0 = TargetX + 48
@@Branch4:
    lsl     r0,r0,10h
    lsr     r2,r0,10h      ; r2 = TargetX +/- 48
@@Branch5:
    mov     r0,2h
    str     r0,[sp]        ; sp[00] = 2
    mov     r0,r3          ; r0 = TargetY +/- 48
    mov     r1,r2          ; r1 = TargetX +/- 48
    mov     r2,10h         ; r2 = 10
    mov     r3,18h         ; r3 = 18
    bl      SpriteMovement
    ldr     r1,=CurrSpriteData
    ldrh    r0,[r1,6h]
    sub     r0,1h
    strh    r0,[r1,6h]     ; sprite[06]--
    lsl     r0,r0,10h
    cmp     r0,0h
    bne     @@Return       ; if sprite[06] == 0
    add     r1,24h
    mov     r0,1Eh
    strb    r0,[r1]          ; SpritePose = 1E
@@Return:
    add     sp,4h
    pop     r0
    bx      r0
    .pool


Pose1E_Leave:
    push    r4,r14
    ldr     r0,=CurrSpriteData
    mov     r3,r0
    add     r3,2Eh
    ldrb    r2,[r3]
    mov     r4,r0
    cmp     r2,0C7h
    bhi     @@Branch1      ; if sprite[2E] <= C7
    add     r0,r2,1
    strb    r0,[r3]          ; sprite[2E]++ (velocity)
@@Branch1:
    ldrb    r0,[r3]
    lsr     r2,r0,3h       ; r2 = sprite[2E] / 8
    ldrh    r1,[r4]
    mov     r0,80h
    lsl     r0,r0,2h
    and     r0,r1
    cmp     r0,0h
    beq     @@Branch2      ; if status has 200
    ldrh    r0,[r4,4h]
    add     r0,r0,r2         ; r0 = SpriteY + sprite[2E] / 8
    b       @@Branch3
    .pool
@@Branch2:
    ldrh    r0,[r4,4h]     ; else
    sub     r0,r0,r2         ; r0 = SpriteY - sprite[2E] / 8
@@Branch3:
    strh    r0,[r4,4h]     ; SpriteY = r0
    mov     r1,r4
    add     r1,2Fh
    ldrb    r0,[r1]
    cmp     r0,0C7h
    bhi     @@Branch4      ; if sprite[2F] <= C7
    add     r0,1h
    strb    r0,[r1]          ; sprite[2F]++
@@Branch4:
    ldrb    r0,[r1]
    lsr     r2,r0,3h       ; r2 = sprite[2F] / 8
    ldrh    r1,[r4]
    mov     r0,80h
    lsl     r0,r0,3h
    and     r0,r1
    cmp     r0,0h
    beq     @@Branch5      ; if status has 400
    ldrh    r0,[r4,2h]
    add     r0,r0,r2         ; r0 = SpriteX + sprite[2F] / 8
    b       @@Branch6
@@Branch5:
    ldrh    r0,[r4,2h]     ; else
    sub     r0,r0,r2         ; r0 = SpriteX - sprite[2F] / 8
@@Branch6:
    strh    r0,[r4,2h]     ; SpriteX = r0
    ldrh    r1,[r4]
    mov     r0,2h
    and     r0,r1
    lsl     r0,r0,10h
    lsr     r0,r0,10h
    cmp     r0,0h
    bne     @@Return       ; if status doesn't have 2 (off screen)
    strh    r0,[r4]          ; status = 0
@@Return:
    pop     r4
    pop     r0
    bx      r0


SpriteAI:
    push    r14
    add     sp,-4h
    ldr     r0,=CurrSpriteData
    mov     r2,r0
    add     r0,24h
    ldrb    r0,[r0]
    cmp     r0,20h
    bls     @@PoseJump
    b       @@Pose62
@@PoseJump:
    lsl     r0,r0,2h
    ldr     r1,=@@JumpTable
    add     r0,r0,r1
    ldr     r0,[r0]
    mov     r15,r0
    .pool

@@JumpTable:
    .word @@Pose0,@@Pose1,@@Pose2
    .word @@Return,@@Return,@@Return,@@Return,@@Return,@@Return,@@Return,@@Return
    .word @@Return,@@Return,@@Return,@@Return,@@Return,@@Return,@@Return,@@Return
    .word @@Return,@@Return,@@Return,@@Return
    .word @@Pose17,@@Pose18,@@Pose19,@@Pose1A
    .word @@Pose1B,@@Pose1C,@@Return,@@Pose1E

@@Pose0:
    bl      Pose0_Init
    ldr     r1,=CurrSpriteData
    ldr     r0,=OAM_Waiting
    str     r0,[r1,18h]
    b       @@Return
    .pool
@@Pose1:
    ldr     r0,=OAM_Waiting
    str     r0,[r2,18h]
    bl      Pose1_StartWaiting
@@Pose2:
    bl      Pose2_Waiting
    b       @@Return
    .pool
@@Pose17:
    ldr     r0,=OAM_Waking
    str     r0,[r2,18h]
    bl      Pose17_StartWaking
@@Pose18:
    bl      Pose18_Waking
    b       @@Return
    .pool
@@Pose19:
    ldr     r0,=OAM_Flying
    str     r0,[r2,18h]
    bl      Pose19_StartRising
@@Pose1A:
    bl      Pose1A_Rising
    b       @@Return
    .pool
@@Pose1B:
    bl      Pose1B_StartFlying
@@Pose1C:
    bl      Pose1C_Flying
    b       @@Return
@@Pose1E:
    bl      Pose1E_Leave
    b       @@Return
@@Pose62:
    ldr     r0,=CurrSpriteData
    ldrh    r1,[r0,2h]
    sub     r1,20h
    ldrh    r2,[r0,4h]
    mov     r0,20h
    str     r0,[sp]
    mov     r0,0h
    mov     r3,1h
    bl      0x8011084
@@Return:
    add     sp,4h
    pop     r0
    bx      r0
    .pool